import onnx
from onnx.backend.test.case.node.lstm import LSTMHelper
from onnx.backend.test.case.node import expect
import numpy as np

input = np.array([[[1.0, 2.0], [3.0, 4.0], [5.0, 6.0]], [[2.0, 3.0], [4.0, 5.0], [6.0, 7.0]]]).astype(np.float32)
print(input.shape)
input_size = 2
hidden_size = 3
weight_scale = 0.1
number_of_gates = 4

node = onnx.helper.make_node(
    "LSTM", inputs=["X", "W", "R"], outputs=["", "Y_h"], hidden_size=hidden_size
)

W = weight_scale * np.ones(
    (1, number_of_gates * hidden_size, input_size)
).astype(np.float32)
R = weight_scale * np.ones(
    (1, number_of_gates * hidden_size, hidden_size)
).astype(np.float32)

lstm = LSTMHelper(X=input, W=W, R=R)
_, Y_h = lstm.step()

print(lstm.C_0 )

seq_length = input.shape[0]
batch_size = input.shape[1]

print(seq_length)
print(np.split(input, input.shape[0], axis=0))

expect(
    node,
    inputs=[input, W, R],
    outputs=[Y_h.astype(np.float32)],
    name="test_lstm_defaults",
)

print(Y_h)